package cn.ibizlab.humanresource.core.humanresource.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.humanresource.core.humanresource.domain.HREmployee;
import cn.ibizlab.humanresource.core.humanresource.filter.HREmployeeSearchContext;
import cn.ibizlab.humanresource.core.humanresource.service.IHREmployeeService;

import cn.ibizlab.humanresource.util.helper.CachedBeanCopier;
import cn.ibizlab.humanresource.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.humanresource.core.humanresource.mapper.HREmployeeMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[员工] 服务对象接口实现
 */
@Slf4j
@Service("HREmployeeServiceImpl")
public class HREmployeeServiceImpl extends ServiceImpl<HREmployeeMapper, HREmployee> implements IHREmployeeService {

    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRArchivesService hrarchivesService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRCertificateService hrcertificateService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRContractService hrcontractService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRDistributionService hrdistributionService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHREducationService hreducationService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRFamilyService hrfamilyService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRLanguageAbilityService hrlanguageabilityService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRPaperService hrpaperService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRPatentService hrpatentService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRResearchService hrresearchService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRRewardService hrrewardService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRTechnicalTitleService hrtechnicaltitleService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRTrainingRecordService hrtrainingrecordService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.pcm.service.IHRTransferApplyService hrtransferapplyService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRWorkRecordService hrworkrecordService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.base.service.IHROrganizationService hrorganizationService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHREmpStateService hrempstateService;
    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRPostService hrpostService;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(HREmployee et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getEmployeeid()),et);
        return true;
    }

    @Override
    public void createBatch(List<HREmployee> list) {
        list.forEach(item->fillParentData(item));
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(HREmployee et) {
        fillParentData(et);
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("employeeid",et.getEmployeeid())))
            return false;
        CachedBeanCopier.copy(get(et.getEmployeeid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<HREmployee> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public HREmployee get(String key) {
        HREmployee et = getById(key);
        if(et==null){
            et=new HREmployee();
            et.setEmployeeid(key);
        }
        else{
        }
        return et;
    }

    @Override
    public HREmployee getDraft(HREmployee et) {
        fillParentData(et);
        return et;
    }

    @Override
    public boolean checkKey(HREmployee et) {
        return (!ObjectUtils.isEmpty(et.getEmployeeid()))&&(!Objects.isNull(this.getById(et.getEmployeeid())));
    }
    @Override
    @Transactional
    public boolean save(HREmployee et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(HREmployee et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public boolean saveBatch(Collection<HREmployee> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    public void saveBatch(List<HREmployee> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
    }


	@Override
    public List<HREmployee> selectByOrganizationid(String organizationid) {
        return baseMapper.selectByOrganizationid(organizationid);
    }

    @Override
    public void removeByOrganizationid(String organizationid) {
        this.remove(new QueryWrapper<HREmployee>().eq("organizationid",organizationid));
    }

	@Override
    public List<HREmployee> selectByEmpstate(String hrempstateid) {
        return baseMapper.selectByEmpstate(hrempstateid);
    }

    @Override
    public void removeByEmpstate(String hrempstateid) {
        this.remove(new QueryWrapper<HREmployee>().eq("empstate",hrempstateid));
    }

	@Override
    public List<HREmployee> selectByHrpostid(String hrpostid) {
        return baseMapper.selectByHrpostid(hrpostid);
    }

    @Override
    public void removeByHrpostid(String hrpostid) {
        this.remove(new QueryWrapper<HREmployee>().eq("hrpostid",hrpostid));
    }


    /**
     * 查询集合 待定工作人员
     */
    @Override
    public Page<HREmployee> searchAfterProbation(HREmployeeSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HREmployee> pages=baseMapper.searchAfterProbation(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HREmployee>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<HREmployee> searchDefault(HREmployeeSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HREmployee> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HREmployee>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 前员工
     */
    @Override
    public Page<HREmployee> searchLeaveDuty(HREmployeeSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HREmployee> pages=baseMapper.searchLeaveDuty(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HREmployee>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 待新签合同人员
     */
    @Override
    public Page<HREmployee> searchNoContract(HREmployeeSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HREmployee> pages=baseMapper.searchNoContract(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HREmployee>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 在岗员工
     */
    @Override
    public Page<HREmployee> searchOnDuty(HREmployeeSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HREmployee> pages=baseMapper.searchOnDuty(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HREmployee>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 待定工作人员
     */
    @Override
    public Page<HREmployee> searchWaitDuty(HREmployeeSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HREmployee> pages=baseMapper.searchWaitDuty(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HREmployee>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(HREmployee et){
        //实体关系[DER1N_EMPLOYEE_ORGANIZATION_ORGANIZATIONID]
        if(!ObjectUtils.isEmpty(et.getOrganizationid())){
            cn.ibizlab.humanresource.core.base.domain.HROrganization organization=et.getOrganization();
            if(ObjectUtils.isEmpty(organization)){
                cn.ibizlab.humanresource.core.base.domain.HROrganization majorEntity=hrorganizationService.get(et.getOrganizationid());
                et.setOrganization(majorEntity);
                organization=majorEntity;
            }
            et.setOrganizationname(organization.getOrganizationname());
        }
        //实体关系[DER1N_HREMPLOYEE_HREMPSTATE_EMPSTATE_BE6FB0]
        if(!ObjectUtils.isEmpty(et.getEmpstate())){
            cn.ibizlab.humanresource.core.humanresource.domain.HREmpState hrempstate=et.getHrempstate();
            if(ObjectUtils.isEmpty(hrempstate)){
                cn.ibizlab.humanresource.core.humanresource.domain.HREmpState majorEntity=hrempstateService.get(et.getEmpstate());
                et.setHrempstate(majorEntity);
                hrempstate=majorEntity;
            }
            et.setJobstate(hrempstate.getJobstate());
        }
        //实体关系[DER1N_HREMPLOYEE_HRPOST_HRPOSTID_BE6FB0]
        if(!ObjectUtils.isEmpty(et.getHrpostid())){
            cn.ibizlab.humanresource.core.humanresource.domain.HRPost hrpost=et.getHrpost();
            if(ObjectUtils.isEmpty(hrpost)){
                cn.ibizlab.humanresource.core.humanresource.domain.HRPost majorEntity=hrpostService.get(et.getHrpostid());
                et.setHrpost(majorEntity);
                hrpost=majorEntity;
            }
            et.setHrpostname(hrpost.getHrpostname());
            et.setHrdutyname(hrpost.getHrdutyname());
        }
    }




    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<HREmployee> getHremployeeByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<HREmployee> getHremployeeByEntities(List<HREmployee> entities) {
        List ids =new ArrayList();
        for(HREmployee entity : entities){
            Serializable id=entity.getEmployeeid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }

}



